import os
import pytest
from eorg.parser import Token
from eorg.parser import parse
from eorg.parser import parse_text


def test_emphasis():
    text = "parse emphasis *bold text* _underlined text_ /italic text/ normal text"
    expected = [Token(token='TEXT', value='parse emphasis ' ), Token(token='b', value='bold text'), Token(token='TEXT', value=' ' ), Token(token='b', value='underlined text'), Token(token='TEXT', value=' ' ), Token(token='b', value='italic text'), Token('TEXT', ' normal text')]
    result = parse_text(text)
    assert expected[0].value == result[0].value
    assert expected[1].value == result[1].value
    assert expected[2].value == result[2].value
    assert expected[3].value == result[3].value
    assert expected[4].value == result[4].value
    assert expected[5].value == result[5].value
    assert expected[6].value == result[6].value


def test_image():
    text = "parse image [[../../test.jpg][test]] after image"
    expected = [
        Token("TEXT", "parse image "),
        Token("IMG", ["../../test.jpg", "test"]),
        Token("TEXT", " after image"),
    ]
    result = parse_text(text)
    assert result[0].value == expected[0].value
    assert result[1].value == expected[1].value
    assert result[2].value == expected[2].value
